/*
 * Decompiled with CFR 0.152.
 * 
 * Could not load the following classes:
 *  fire.pb.WorldEventTab
 *  mkdb.Mkdb
 *  mkdb.MkdbConf
 *  mkdb.TTable
 *  mkdb.Table
 *  mkdb.util.UniqName
 *  org.apache.log4j.Logger
 */
package fire.pb.main;

import fire.pb.WorldEventTab;
import fire.pb.main.ModuleInterface;
import fire.pb.main.ReloadResult;
import java.io.File;
import java.io.PrintWriter;
import java.util.Calendar;
import java.util.Collection;
import mkdb.Mkdb;
import mkdb.MkdbConf;
import mkdb.TTable;
import mkdb.Table;
import mkdb.util.UniqName;
import org.apache.log4j.Logger;

public class MkdbModule
implements ModuleInterface {
    private static Logger logger = Logger.getLogger((String)"SYSTEM");
    private Mkdb mkdb;

    @Override
    public void exit() {
        if (this.mkdb != null) {
            this.mkdb.stop();
        }
        logger.info((Object)"mkdb已关闭");
    }

    @Override
    public void init() throws Exception {
        MkdbConf conf = new MkdbConf("gsx.mkdb.xml");
        this.mkdb = Mkdb.getInstance();
        this.mkdb.setConf(conf);
        conf.getDbHome().mkdirs();
        conf.getBackupDir().mkdirs();
        UniqName.initialize();
        File inUse = new File("mkdb/mkdb.inuse");
        if (inUse.exists()) {
            inUse.delete();
        }
        this.mkdb.start();
        new WorldEventTab().start();
    }

    @Override
    public ReloadResult reload() throws Exception {
        return new ReloadResult(false, "module" + this.getClass().getName() + "not support reload");
    }

    /*
     * WARNING - Removed try catching itself - possible behaviour change.
     */
    public void printTableCacheInfo(long useMemory, long freeMemory) {
        try {
            Calendar cal = Calendar.getInstance();
            StringBuilder sb = new StringBuilder();
            sb.append("Cache");
            sb.append(String.valueOf(cal.get(2) + 1)).append("_");
            sb.append(String.valueOf(cal.get(5))).append("_");
            sb.append(String.valueOf(cal.get(11))).append("_");
            sb.append(String.valueOf(cal.get(12))).append("_");
            sb.append(String.valueOf(useMemory)).append("_");
            sb.append(String.valueOf(freeMemory)).append("_");
            try (PrintWriter fw = null;){
                File cacheFilesFolder = new File("cachefiles");
                if (!cacheFilesFolder.exists()) {
                    cacheFilesFolder.mkdir();
                }
                if (cacheFilesFolder.list().length > 100) {
                    for (File subFile : cacheFilesFolder.listFiles()) {
                        subFile.delete();
                    }
                }
                fw = new PrintWriter(new File(cacheFilesFolder, sb.toString()));
                fw.write(this.addBlank("TableName", 32) + "\t");
                fw.write(this.addBlank("Memory", 6) + "\t");
                fw.write("Cache Cap\t");
                fw.write("Cache Size\t");
                fw.write("Count Add\t");
                fw.write("Count Add Miss\t");
                fw.write("Count Add Stor\t");
                fw.write("Count Get\t");
                fw.write("Count Get Miss\t");
                fw.write("Count Get Stor\t");
                fw.write("Count RMV\t");
                fw.write("Count RMV Miss\t");
                fw.write("Count RMV Stor\t");
                fw.write("\n");
                Collection tables = this.mkdb.getTables().getTables();
                for (Table table : tables) {
                    if (!(table instanceof TTable)) continue;
                    TTable tTable = (TTable)table;
                    fw.write(this.addBlank(table.getName(), 32) + "\t");
                    fw.write(this.addBlank(String.valueOf(table.getPersistence()), 6) + "\t");
                    fw.write(this.addBlank(String.valueOf(tTable.getCacheCapacity()), 9) + "\t");
                    fw.write(this.addBlank(String.valueOf(tTable.getCacheSize()), 10) + "\t");
                    fw.write(this.addBlank(String.valueOf(tTable.getCountAdd()), 9) + "\t");
                    fw.write(this.addBlank(String.valueOf(tTable.getCountAddMiss()), 14) + "\t");
                    fw.write(this.addBlank(String.valueOf(tTable.getCountAddStorageMiss()), 14) + "\t");
                    fw.write(this.addBlank(String.valueOf(tTable.getCountGet()), 9) + "\t");
                    fw.write(this.addBlank(String.valueOf(tTable.getCountGetMiss()), 14) + "\t");
                    fw.write(this.addBlank(String.valueOf(tTable.getCountGetStorageMiss()), 14) + "\t");
                    fw.write(this.addBlank(String.valueOf(tTable.getCountRemove()), 9) + "\t");
                    fw.write(this.addBlank(String.valueOf(tTable.getCountRemoveMiss()), 14) + "\t");
                    fw.write(this.addBlank(String.valueOf(tTable.getCountRemoveStorageMiss()), 14) + "\t");
                    fw.write("\n");
                }
                fw.flush();
            }
        }
        catch (Throwable e) {
            logger.error((Object)"print table cache failed", e);
        }
    }

    private String addBlank(String str, int len) {
        StringBuilder sb = new StringBuilder(str);
        while (sb.length() < len) {
            sb.append(" ");
        }
        return sb.toString();
    }
}

